{***************************************************************************
                    BitInidikatorKonfig.pas  -  description
                             -------------------
    begin             : 03.12.2012
    copyright         : (C) 2012 by MHS-Elektronik GmbH & Co. KG, Germany
    autho             : Klaus Demlehner, klaus@mhs-elektronik.de
 ***************************************************************************}

{***************************************************************************
 *                                                                         *
 *   This program is free software, you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License           *
 *   version 2.1 as published by the Free Software Foundation.             *
 *                                                                         *
 ***************************************************************************}
unit BitIndikatorKonfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Buttons, ExtCtrls, IniFiles, StrUtils;

type
  TBitKonfigForm = class(TForm)
    RahmenBevel: TBevel;
    Label1: TLabel;
    Label9: TLabel;
    CANIDEdit: TEdit;
    OKBtn: TBitBtn;
    AbbrechenBtn: TBitBtn;
    NameEdit: TEdit;
    LadenBtn: TBitBtn;
    SpeichernBtn: TBitBtn;
    BitNameGrid: TStringGrid;
    HinzufuegenBtn: TBitBtn;
    Bevel1: TBevel;
    Label3: TLabel;
    EntfernenBtn: TBitBtn;
    BitComboBox: TComboBox;
    ColorBox: TColorBox;
    procedure FormCreate(Sender: TObject);
    procedure ComboBoxExit(Sender: TObject);
    procedure ColorBoxExit(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure LadenBtnClick(Sender: TObject);
    procedure SpeichernBtnClick(Sender: TObject);
    procedure CANIDEditChange(Sender: TObject);
    procedure CANIDEditEnter(Sender: TObject);
    procedure CANIDEditExit(Sender: TObject);
    procedure HinzufuegenBtnClick(Sender: TObject);
    procedure EntfernenBtnClick(Sender: TObject);
    procedure BitNameGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure BitNameGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure BitNameGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure BitNameGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
  private
    { Private-Deklarationen }
    Dateiname: string;
    BitConfListe: TList;
    procedure AddBitConfItem(line: Integer);
    procedure CMDialogKey(var msg: TCMDialogKey); message CM_DIALOGKEY;
  public
    { Public-Deklarationen }    
    procedure SetBitConfListe(liste: TList);
    procedure GetBitConfListe(liste: TList);    
  end;

implementation

uses Hauptfenster, BitIndikator;

{$R *.dfm}

procedure TBitKonfigForm.FormCreate(Sender: TObject);
begin
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(0, OKBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(1, AbbrechenBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(5, LadenBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(4, SpeichernBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(2, HinzufuegenBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(3, EntfernenBtn.Glyph);
  BitConfListe := TList.Create;

  BitNameGrid.ColWidths[0] := 125;
  BitNameGrid.Cells[0, 0] := 'Bezeichnung';
  BitNameGrid.ColWidths[1] := 90;
  BitNameGrid.Cells[1, 0] := 'Farbe';
  BitNameGrid.ColWidths[2] := 40;
  BitNameGrid.Cells[2, 0] := 'Byte';
  BitNameGrid.ColWidths[3] := 40;
  BitNameGrid.Cells[3, 0] := 'Bit';
  BitNameGrid.DefaultRowHeight := BitComboBox.Height;

  BitComboBox.Parent := BitNameGrid;
  BitComboBox.Visible := False;

  ColorBox.Parent := BitNameGrid;
  ColorBox.Visible := False;

  AddBitConfItem(1);
end;


procedure TBitKonfigForm.FormDestroy(Sender: TObject);
begin
TBitIndikatorForm(Owner).BitConfListeClear(BitConfListe);
BitConfListe.Free;
end;


procedure TBitKonfigForm.SetBitConfListe(liste: TList);
var i: Integer;
    item: PBitConf;

begin;
if liste.Count = 0 then
  exit;
TBitIndikatorForm(Owner).BitConfListeClear(BitConfListe);
for i := 0 to liste.Count-1 do
  begin
  new(item);
  item.Name := PBitConf(liste[i]).Name;       // Bezeichnung
  item.Color := PBitConf(liste[i]).Color;     // Farbe
  item.BytePos := PBitConf(liste[i]).BytePos; // Byte
  item.BitPos := PBitConf(liste[i]).BitPos;   // Bit
  BitConfListe.Add(item);
  end;
BitNameGrid.RowCount := liste.Count + 1;  
BitNameGrid.Refresh;
end;


procedure TBitKonfigForm.GetBitConfListe(liste: TList);
var i: Integer;
    item: PBitConf;
     
begin;
if BitConfListe.Count = 0 then
  exit;
TBitIndikatorForm(Owner).BitConfListeClear(liste);  
for i := 0 to BitConfListe.Count-1 do
  begin
  new(item);
  item.Name := PBitConf(BitConfListe[i]).Name;       // Bezeichnung
  item.Color := PBitConf(BitConfListe[i]).Color;     // Farbe
  item.BytePos := PBitConf(BitConfListe[i]).BytePos; // Byte
  item.BitPos := PBitConf(BitConfListe[i]).BitPos;   // Bit
  liste.Add(item);
  end;
end;


procedure TBitKonfigForm.AddBitConfItem(line: Integer);
var item: PBitConf;

begin;
new(item);
item.Name := Format('LED %u', [line]); // Bezeichnung
item.Color := clRed;                     // Farbe
item.BytePos := 0;                       // Byte
item.BitPos := 0;                        // Bit
BitConfListe.Add(item);
end;


procedure TBitKonfigForm.HinzufuegenBtnClick(Sender: TObject);
var line: Integer;

begin
if  BitNameGrid.RowCount < 24 then
  begin
  line := BitNameGrid.RowCount;
  AddBitConfItem(line);
  inc(line);
  BitNameGrid.RowCount := line;
  BitNameGrid.Refresh;
  end;
end;


procedure TBitKonfigForm.EntfernenBtnClick(Sender: TObject);
var item_index: Integer;

begin
if BitNameGrid.RowCount > 2 then
  begin
  item_index := BitNameGrid.RowCount - 1;
  dispose(BitConfListe.Items[item_index-1]);
  BitConfListe.Delete(item_index-1);
  BitNameGrid.RowCount := item_index;
  end;
end;


procedure TBitKonfigForm.CMDialogKey(var msg: TCMDialogKey);
begin
if (ActiveControl = BitComboBox) or
   (ActiveControl = ColorBox) then
  begin
  if msg.CharCode = VK_TAB then
    begin
    // setzt den Fokus zurück auf das StringGrid
    BitNameGrid.SetFocus;
    BitNameGrid.Perform(WM_KEYDOWN, msg.CharCode, msg.KeyData);
    msg.Result := 1;
    exit;
    end;
  end;
inherited;
end;


procedure TBitKonfigForm.ComboBoxExit(Sender: TObject);
begin
TComboBox(sender).hide;
case BitNameGrid.Col of
  2 : PBitConf(BitConfListe[BitNameGrid.row-1]).BytePos := TComboBox(sender).ItemIndex;
  3 : PBitConf(BitConfListe[BitNameGrid.row-1]).BitPos := TComboBox(sender).ItemIndex;
  end;
end;


procedure TBitKonfigForm.ColorBoxExit(Sender: TObject);
begin
TColorBox(sender).hide;
PBitConf(BitConfListe[BitNameGrid.row-1]).Color := TColorBox(sender).Selected;
BitNameGrid.Repaint;
end;


procedure TBitKonfigForm.BitNameGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var
  Str: String;
  R: TRect;
  org: TPoint;
  box_obj: TComboBox;

begin
if (ACol in [1, 2, 3]) and (ARow >= BitNameGrid.FixedRows) then
  begin
  BitNameGrid.Perform(WM_CANCELMODE, 0, 0);
  R := BitNameGrid.CellRect(ACol, ARow);
  org := self.ScreenToClient(self.ClientToScreen(R.TopLeft));
  Str := BitNameGrid.Cells[ACol, ARow];
  case ACol of
    1 : begin
        box_obj := TComboBox(ColorBox);
        ColorBox.Selected := PBitConf(BitConfListe[ARow-1]).Color;
        end;
    2 : begin
        box_obj := BitComboBox;
        BitComboBox.ItemIndex := PBitConf(BitConfListe[ARow-1]).BytePos;
        end;
    3 : begin;
        box_obj := BitComboBox;
        BitComboBox.ItemIndex := PBitConf(BitConfListe[ARow-1]).BitPos;
        end;
    else
        exit;    
    end;
  box_obj.SetBounds(org.X, org.Y, R.Right-R.Left, BitNameGrid.Height);  
  box_obj.Show;
  box_obj.BringToFront;
  box_obj.SetFocus;
  box_obj.DroppedDown := true;
  end;
end;


procedure TBitKonfigForm.BitNameGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  Str: string;
  R: TRect;
  SelColor: TColor;
begin
BitNameGrid.Canvas.Brush.Color := BitNameGrid.Color;
BitNameGrid.Canvas.Font.Color := clWindowText;

if gdFocused in State then
  begin
  BitNameGrid.Canvas.Brush.Color := clActiveCaption;
  BitNameGrid.Canvas.Font.Color := clCaptionText;
  end
else
  if gdFixed in State then
    BitNameGrid.Canvas.Brush.Color := BitNameGrid.FixedColor;
//BitNameGrid.Canvas.FillRect(Rect);

if ARow = 0 then
  BitNameGrid.Canvas.TextOut(Rect.Left+1,Rect.Top+2, BitNameGrid.Cells[ACol, ARow])
else
  begin
  case ACol of
    0 : BitNameGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+2,
                  PBitConf(BitConfListe[ARow-1]).Name); // Bezeichnung
    1 : begin  // Farbe
        SelColor := PBitConf(BitConfListe[ARow-1]).Color;
        with BitNameGrid.Canvas do
          begin;
          Pen.Color := clBlack;
          Brush.Color := clWhite;
          FillRect(Rect);
          Rectangle(Rect.Left+4,Rect.Top+2,Rect.Left+20,Rect.Bottom-3);
          Brush.Color := SelColor;
          R.Left := Rect.Left+5;
          R.Top := Rect.Top+3;
          R.Right := Rect.Left+19;
          R.Bottom := Rect.Bottom-4;
          FillRect(R);
          Brush.Color := BitNameGrid.Color;
          Font.Color := clWindowText;
          TextOut(Rect.Left+24, Rect.Top+2, ColorToString(SelColor));
          end;
        end;
    2 : begin   // Byte
        Str := Format('%u', [PBitConf(BitConfListe[ARow-1]).BytePos]);
        BitNameGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+2, Str);
        end;
    3 : begin   // Bit
        Str := Format('%u', [PBitConf(BitConfListe[ARow-1]).BitPos]);
        BitNameGrid.Canvas.TextOut(Rect.Left+1, Rect.Top+2, Str);
        end;
    end;
  end;
end;


procedure TBitKonfigForm.BitNameGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin
if BitNameGrid.Row > BitConfListe.Count then
  exit;
if ACol = 0 then
  Value := PBitConf(BitConfListe[ARow-1]).Name;
end;


procedure TBitKonfigForm.BitNameGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
if BitNameGrid.Row > BitConfListe.Count then
  exit;
if ACol = 0 then
  begin
  if length(Value) < 40 then
    PBitConf(BitConfListe[ARow-1]).Name := Value;
  end;
end;


procedure TBitKonfigForm.CANIDEditChange(Sender: TObject);
begin
  TMainForm(Owner.Owner).CheckZahlenTEditEingabe(TEdit(Sender), TMainForm(Owner.Owner).MaxID);
end;

procedure TBitKonfigForm.CANIDEditEnter(Sender: TObject);
begin
  TEdit(Sender).Text := TMainForm(Owner.Owner).GetIDString(TEdit(Sender).Tag);
end;

procedure TBitKonfigForm.CANIDEditExit(Sender: TObject);
begin
  TMainForm(Owner.Owner).HexEditViewValue(Sender);
end;


procedure TBitKonfigForm.OKBtnClick(Sender: TObject);
begin
Dateiname := '';
ModalResult := mrOK;
end;


procedure TBitKonfigForm.LadenBtnClick(Sender: TObject);
var
  i, n: integer;
  IniDatei: TIniFile;
  BitListe: TStrings;
begin
  TMainForm(Owner.Owner).OpenDialog.Title := 'Instrumenten-Einstellungen laden';
  TMainForm(Owner.Owner).OpenDialog.DefaultExt := 'cin';
  TMainForm(Owner.Owner).OpenDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

  if TMainForm(Owner.Owner).OpenDialog.Execute then
  begin
    IniDatei := TIniFile.Create(TMainForm(Owner.Owner).OpenDialog.FileName);
    try
      NameEdit.Text := IniDatei.ReadString('Allgemein', 'Name', TMainForm(Owner.Owner).OpenDialog.FileName);
      Dateiname := NameEdit.Text;
      CANIDEdit.Tag := IniDatei.ReadInteger('Allgemein', 'CanID', 0);
      CANIDEdit.Text := TMainForm(Owner.Owner).GetIDString(CANIDEdit.Tag);

      BitListe := TStringList.Create;
      IniDatei.ReadSection('BitIndikator', BitListe);
      BitNameGrid.RowCount := 2;
      BitNameGrid.Cells[1, 1] := '';
      for i := 0 to BitListe.Count-1 do
      begin
        if AnsiStartsText('Bit', BitListe.Strings[i]) then
        begin
          n := StrToInt(copy(BitListe.Strings[i], 4, 4));
          while (n >= BitNameGrid.RowCount - 1) do
            BitNameGrid.RowCount := BitNameGrid.RowCount + 1;
          BitNameGrid.Cells[1, n+1] := IniDatei.ReadString('BitIndikator',
                BitListe.Strings[i], BitNameGrid.Cells[1, n+1]);
        end;
      end;
      BitListe.Free;

      //FormShow(self);
    finally
      IniDatei.Free;
    end;
  end;
end;

procedure TBitKonfigForm.SpeichernBtnClick(Sender: TObject);
var
  i: integer;
  IniDatei: TIniFile;
begin
  TMainForm(Owner.Owner).SaveDialog.Title := 'Instrumenten-Einstellungen speichern';
  TMainForm(Owner.Owner).SaveDialog.DefaultExt := 'cin';
  if Dateiname = '' then
    TMainForm(Owner.Owner).SaveDialog.FileName := NameEdit.Text + '.cin'
  else
    TMainForm(Owner.Owner).SaveDialog.FileName := Dateiname;
  TMainForm(Owner.Owner).SaveDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

  if TMainForm(Owner.Owner).SaveDialog.Execute then
  begin
    Dateiname := TMainForm(Owner.Owner).SaveDialog.FileName;
    IniDatei := TIniFile.Create(TMainForm(Owner.Owner).SaveDialog.FileName);
    try
      IniDatei.WriteString('Allgemein', 'Name', NameEdit.Text);
      IniDatei.WriteInteger('Allgemein', 'CanID', CANIDEdit.Tag);
      for i := 1 to BitNameGrid.RowCount-1 do
        IniDatei.WriteString('BitIndikator', format('Bit%u', [i - 1]), BitNameGrid.Cells[1, i]);
    finally
      IniDatei.Free;
    end;

  end;
end;



end.
