unit Hauptfenster;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, Menus, ComCtrls, IniFiles, StdCtrls, ExtCtrls, Buttons,
  ToolWin, Grids, StrUtils, ImgList, FTDI, TinyCanDrv;

const
  WM_SENDETIMER = WM_USER + 10;

  CANBaudParameter: array [0..8] of String =
       (' 10 kBit/s',
        ' 20 kBit/s',
        ' 50 kBit/s',
        '100 kBit/s',
        '125 kBit/s',
        '250 kBit/s',
        '500 kBit/s',
        '800 kBit/s',
        '  1 MBit/s');

  DrvStatusStrings: array[0..8] of String =
     ('Treiber DLL nicht geladen',         // Die Treiber DLL wurde noch nicht geladen
      'Treiber nicht Initialisiert ',      // Treiber noch nicht Initialisiert (Funktion "CanInitDrv" noch nicht aufgerufen)
      'Treiber DLL geladen',               // Treiber erfolgrich Initialisiert
      'Port kann nicht geffnet werden',   // Die Schnittstelle wurde nicht geffnet
      'System wird Initialisiert ...',     // Die Schnittstelle wurde geffnet
      'System wird Initialisiert ...',     // Verbindung zur Hardware wurde Hergestellt
      'System Online',                     // Device wurde geffnet und erfolgreich Initialisiert
      'System Online',                     // CAN Bus RUN nur Transmitter (wird nicht verwendet !)
      'System Online');                    // CAN Bus RUN

  CanStatusStrings: array[0..5] of String =
     ('CAN: Ok',                  // Ok
      'CAN: Error',               // CAN Error
      'CAN: Error warning',       // Error warning
      'CAN: Error passiv',        // Error passiv
      'CAN: Bus Off',             // Bus Off
      'CAN: Unbek. Fehler');      // Status Unbekannt

type

  TCANrecord = record
    ID: dword;
    Timestamp: dword;
    Cmd: byte;
    DLC: byte;
    Data: array[0..7] of byte;
    MsgAnzahl: dword;        // Dient zum errechnen des Intervals
    IntervalSumme: dword;    // Dient zum errechnen des Intervals
  end;
  PCANrecord = ^TCANrecord;

  TMainForm = class(TForm)
    HauptMenu: TMainMenu;
    DateiMnu: TMenuItem;
    HilfeMnu: TMenuItem;
    Info1: TMenuItem;
    BeendenMnu: TMenuItem;
    ActionList: TActionList;
    EinstellungenMnu: TMenuItem;
    N1: TMenuItem;
    actEinstellungen: TAction;
    actBeenden: TAction;
    actInfo: TAction;
    SchnittstelleffnenMnu: TMenuItem;
    N2: TMenuItem;
    actVerbinden: TAction;
    StatusBar: TStatusBar;
    AnsichtMnu: TMenuItem;
    FensterMnu: TMenuItem;
    DezIDMnu: TMenuItem;
    actDezID: TAction;
    actHexID: TAction;
    actBinID: TAction;
    HexIDMnu: TMenuItem;
    CheckerImages: TImageList;
    CANTimeOut: TTimer;
    N3: TMenuItem;
    EmpfangsFensterMnu: TMenuItem;
    SendenFensterMnu: TMenuItem;
    ProtokollMnu: TMenuItem;
    actEmpfangsFenster: TAction;
    actSendeFenster: TAction;
    actProtokoll: TAction;
    StandardIDMnu: TMenuItem;
    ErweiterteIDMnu: TMenuItem;
    N4: TMenuItem;
    actStandardID: TAction;
    actErweiterteID: TAction;
    ButtonImages: TImageList;
    CANControllerMnu: TMenuItem;
    DezDatenMnu: TMenuItem;
    HexDatenMnu: TMenuItem;
    BinDatenMnu: TMenuItem;
    actDezDaten: TAction;
    actHexDaten: TAction;
    actBinDaten: TAction;
    USBImages: TImageList;
    SaveDialog: TSaveDialog;
    N5: TMenuItem;
    ResetMnu: TMenuItem;
    OpenDialog: TOpenDialog;
    actZaehlerReset: TAction;
    ZaehlerResetMnu: TMenuItem;
    ToolBar: TToolBar;
    VerindenToolBtn: TToolButton;
    ToolImageList: TImageList;
    ToolButton2: TToolButton;
    actAnalogInstrumentFenster: TAction;
    AnalogInstrumentMnu: TMenuItem;
    actOszillogrammFenster: TAction;
    OszilogrammMnu: TMenuItem;
    actWertAnzeigeFenster: TAction;
    actBitIndikatorFenster: TAction;
    WertAnzeigeMnu: TMenuItem;
    BitIndikatorMnu: TMenuItem;
    actNextMDI: TAction;
    actPrevMDI: TAction;
    NextMDIMnu: TMenuItem;
    PrevMDIMnu: TMenuItem;
    N6: TMenuItem;
    actInstrumentOeffnen: TAction;
    OeffnenMnu: TMenuItem;
    N7: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    DongleListPopup: TPopupMenu;
    TinyCAN: TTinyCAN;

    procedure FormCreate(Sender: TObject);
    procedure actEinstellungenExecute(Sender: TObject);
    procedure actBeendenExecute(Sender: TObject);
    procedure actInfoExecute(Sender: TObject);
    procedure actVerbindenExecute(Sender: TObject);
    procedure actEmpfangsFensterExecute(Sender: TObject);
    procedure actSendeFensterExecute(Sender: TObject);
    procedure actStandardIDExecute(Sender: TObject);
    procedure actErweiterteIDExecute(Sender: TObject);
    procedure actProtokollExecute(Sender: TObject);
    procedure actDezIDExecute(Sender: TObject);
    procedure actHexIDExecute(Sender: TObject);
    procedure actBinIDExecute(Sender: TObject);
    procedure actDezDatenExecute(Sender: TObject);
    procedure actHexDatenExecute(Sender: TObject);
    procedure actBinDatenExecute(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
    procedure FormShow(Sender: TObject);
    procedure actZaehlerResetExecute(Sender: TObject);
    procedure actAnalogInstrumentFensterExecute(Sender: TObject);
    procedure actOszillogrammFensterExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actWertAnzeigeFensterExecute(Sender: TObject);
    procedure actBitIndikatorFensterExecute(Sender: TObject);
    procedure actNextMDIExecute(Sender: TObject);
    procedure actPrevMDIExecute(Sender: TObject);
    procedure actInstrumentOeffnenExecute(Sender: TObject);
    procedure ProtokollAddLine(s: string);
    procedure DongleListPopupPopup(Sender: TObject);
    procedure OnPopupMenuItemClick(Sender: TObject);
    procedure TinyCANCanRxDEvent(Sender: TObject; index: Cardinal;
      msg: PCanMsg; count: Integer);
    procedure TinyCANCanStatusEvent(Sender: TObject; index: Cardinal;
      device_status: TDeviceStatus);
    procedure ResetMnuClick(Sender: TObject);
  private
    { Private-Deklarationen }
    LizenzAnzeige: boolean;
    VerbindungsStat: integer;   // Marker fr Iconanzeige in der Statusbar

    RxNachrichtenCount: integer;
    TxNachrichtenCount: integer;
    PufferAktuell: integer;
    PufferMax: integer;
    DongleSerNr: string;
    DongleActive: boolean;
    function Verbinden(): integer;
    procedure CloseDevice();
    procedure Trennen();
    procedure CANReset();
    procedure RefreshPanel();
    procedure RefreshMDIClients();
    procedure RefreshStatusBar();
    function  MDIClientOeffnen(ClientForm: TFormClass): TForm;
  public
    { Public-Deklarationen }
    DrvStatus: TDrvStatus;
    CanStatus: TCanStatus;

    IDLaenge: integer;
    MaxID: dword;

    CANBaudIdx: integer;
    ListenOnlyAktiv: boolean;
    RxRefreshRate: integer;
    ASCIISpalteAktiv: boolean;

    ProtokollForm: TForm;
    EmpfangDatei: string;
    SendenDatei: string;

    function  MenuMDIClientHinzufuegen(Sender: TForm): TMenuItem;
    procedure MenuMDIClientEntfernen(MenuItem: TMenuItem);
    procedure HexEditViewValue(Sender: TObject);
    function  GetIDString(ID: dword): string;
    function  GetDataString(Data: dword): string;
    function  CheckZahlenEingabe(NumString: string; var Value: dword; MaxValue: dword): integer; overload;
    function  CheckZahlenEingabe(NumString: string; var Value: word; MaxValue: dword): integer; overload;
    function  CheckZahlenEingabe(NumString: string; var Value: byte; MaxValue: dword): integer; overload;
    function  CheckZahlenTEditEingabe(Sender: TEdit; MaxValue: dword): integer;
    procedure IncTxZaehler();
  end;

  TThreadNameInfo = record
    FType: dword;     // muss 0x1000 sein
    FName: PChar;        // Zeiger auf Name (in Anwender-Adress-Bereich)
    FThreadID: dword; // Thread-ID (-1 ist Caller-Thread)
    FFlags: dword;    // reserviert fr zuknftige Verwendung, muss 0 sein
  end;


var
  MainForm: TMainForm;

{ Globale Funktionen }

function SwapBytes(Value: dword): dword;
procedure SwapBytesP(Value: pdword);
procedure SwapBytesC(Value: dword; Ziel: pdword);
function ReadListInteger(Liste: TStrings; Name: string; Standard: integer): integer;
function ReadListString(Liste: TStrings; Name: string; Standard: string): string;

implementation

{$R *.dfm}

uses
  Einstellungen, Info, Empfang, Senden, Protokoll,
  EmpfangPrototyp, AnalogInstrument, Oszillogramm, WertAnzeige, BitIndikator;

function SwapBytes(Value: dword): dword;
asm
  bswap eax;
end;

procedure SwapBytesP(Value: pdword);
asm
  mov edx,[eax];
  bswap edx;
  mov [eax],edx;
end;

procedure SwapBytesC(Value: dword; Ziel: pdword);
asm
  bswap eax;
  mov [edx],eax;
end;

function ReadListInteger(Liste: TStrings; Name: string; Standard: integer): integer;
var
  s: string;
begin
  s := Liste.Values[Name];
  if s <> '' then
  begin
    try
      result := StrToInt(s);
    except
      result := Standard;
    end;
  end
  else
    result := Standard;
end;

function ReadListString(Liste: TStrings; Name: string; Standard: string): string;
begin
  result := Liste.Values[Name];
  if result = '' then
    result := Standard;
end;

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
var
  IniDatei: TIniFile;
  InfoForm: TInfoForm;
begin
  ProtokollForm := nil;

  VerbindungsStat := 0;

  RxNachrichtenCount := 0;
  TxNachrichtenCount := 0;
  StatusBar.Font.Style := [];
  RefreshStatusBar;

  actHexID.Execute;
  actStandardID.Execute;
  DongleActive := false;

  IniDatei := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini') );
  try
    LizenzAnzeige := IniDatei.ReadBool('Allgemein', 'Lizenz', true);
    DongleSerNr := IniDatei.ReadString('Allgemein', 'DongleSerienNr', '');
    CANBaudIdx := IniDatei.ReadInteger('CAN', 'BaudIdx', 3);
    ListenOnlyAktiv := IniDatei.ReadBool('CAN', 'ListenOnly', true);
    RxRefreshRate := IniDatei.ReadInteger('Allgemein', 'RxRefresh', 0);
    ASCIISpalteAktiv := IniDatei.ReadBool('Allgemein', 'RxASCIIAnzeige', false);

    Left := IniDatei.ReadInteger('AppliFenster', 'XPos', 0);
    Top := IniDatei.ReadInteger('AppliFenster', 'YPos', 0);
    Width := IniDatei.ReadInteger('AppliFenster', 'Breite', 0);
    Height := IniDatei.ReadInteger('AppliFenster', 'Hoehe', 0);
  finally
    IniDatei.Free;
  end;

  //Trennen; <*>
  RefreshPanel;

  EmpfangDatei := '';
  SendenDatei := '';

  if LizenzAnzeige then
  begin
    InfoForm := TInfoForm.Create(self);
    if InfoForm.ShowModal = mrOK then
      LizenzAnzeige := not InfoForm.CheckBox.Checked;
    InfoForm.Free;
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  i: integer;
  IniDatei: TIniFile;
  SectionsListe: TStringList;
  WerteListe: TStringList;
  FormularClass: TClass;
  Form: TForm;
begin
  SectionsListe := TStringList.Create;
  WerteListe := TStringList.Create;

  IniDatei := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniDatei.ReadSections(SectionsListe);
    for i := SectionsListe.Count - 1 downto 0 do
    begin
      if AnsiStartsText('MDIFormular', SectionsListe.Strings[i]) then
      begin
        FormularClass := GetClass(
              IniDatei.ReadString(SectionsListe.Strings[i], 'Typ', ''));
        if FormularClass <> nil then
        begin
          Form := MDIClientOeffnen(TFormClass(FormularClass));
          Form.Left := IniDatei.ReadInteger(SectionsListe.Strings[i], 'XPos', 0);
          Form.Top := IniDatei.ReadInteger(SectionsListe.Strings[i], 'YPos', 0);
          Form.Width := IniDatei.ReadInteger(SectionsListe.Strings[i], 'Breite', 0);
          Form.Height := IniDatei.ReadInteger(SectionsListe.Strings[i], 'Hoehe', 0);
          if Form is TEmpfangPrototypForm then
          begin
            WerteListe.Clear;
            IniDatei.ReadSectionValues(SectionsListe.Strings[i], WerteListe);
            TEmpfangPrototypForm(Form).KonfigLaden(WerteListe);
          end;
          if Form is TProtokollForm then
            ProtokollForm := Form;
        end;
      end;
    end;
  finally
    WerteListe.Free;
    SectionsListe.Free;
    IniDatei.Free;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i, j: integer;
  IniDatei: TIniFile;
  IniSections: TStringList;
  WerteListe: TStringList;
  Form: TForm;
  name: String;
begin
  WerteListe := TStringList.Create;

  IniDatei := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniDatei.WriteBool('Allgemein', 'Lizenz', LizenzAnzeige);
    IniDatei.WriteString('Allgemein', 'DongleSerienNr', DongleSerNr);
    IniDatei.WriteInteger('CAN', 'BaudIdx', CANBaudIdx);
    IniDatei.WriteBool('CAN', 'ListenOnly', ListenOnlyAktiv);
    IniDatei.WriteInteger('Allgemein', 'RxRefresh', RxRefreshRate);
    IniDatei.WriteBool('Allgemein', 'RxASCIIAnzeige', ASCIISpalteAktiv);
    IniDatei.WriteInteger('AppliFenster', 'XPos', Left);
    IniDatei.WriteInteger('AppliFenster', 'YPos', Top);
    IniDatei.WriteInteger('AppliFenster', 'Breite', Width);
    IniDatei.WriteInteger('AppliFenster', 'Hoehe', Height);

    IniSections := TStringList.Create;
    IniDatei.ReadSections(IniSections);
    for i := 0 to IniSections.Count - 1 do
    begin
      if AnsiStartsText('MDIFormular', IniSections.Strings[i]) then
      begin
        IniDatei.EraseSection(IniSections.Strings[i]);
      end;
    end;
    IniSections.Free;
    if MDIChildCount > 0 then
      begin;
      for i := 0 to MDIChildCount-1 do
        begin
        Form := self.MDIChildren[i];
        IniDatei.WriteString(format('MDIFormular%u',[i]), 'Typ', Form.ClassName);
        IniDatei.WriteInteger(format('MDIFormular%u',[i]), 'XPos', Form.Left);
        IniDatei.WriteInteger(format('MDIFormular%u',[i]), 'YPos', Form.Top);
        IniDatei.WriteInteger(format('MDIFormular%u',[i]), 'Breite', Form.Width);
        IniDatei.WriteInteger(format('MDIFormular%u',[i]), 'Hoehe', Form.Height);
        if Form is TEmpfangPrototypForm then
          begin
          WerteListe.Clear;
          TEmpfangPrototypForm(Form).KonfigSichern(WerteListe);
          for j := 0 to WerteListe.Count - 1 do
            begin;
            name := WerteListe.Names[j];
            IniDatei.WriteString(format('MDIFormular%u',[i]), name, WerteListe.Values[name]);
            end;
          // <*> ValueFromIndex ist in Delphi 6 noch nicht vohanden  
          //  IniDatei.WriteString(format('MDIFormular%u',[i]), WerteListe.Names[j], WerteListe.ValueFromIndex[j]);
          end;
        end;
      end;        
  finally
    WerteListe.Free;
    IniDatei.Free;
  end;
end;

function TMainForm.MenuMDIClientHinzufuegen(Sender: TForm): TMenuItem;
begin
  result := TMenuItem.Create(self);
  result.Caption := Sender.Caption;
  result.OnClick := Sender.OnShow;
  Hauptmenu.Items.Find('Fenster').Add(result);
end;

procedure TMainForm.MenuMDIClientEntfernen(MenuItem: TMenuItem);
var
  MenuItemIndex: integer;
begin
  if assigned(Hauptmenu) then
  begin
    MenuItemIndex := Hauptmenu.Items.Find('Fenster').IndexOf(MenuItem);
    Hauptmenu.Items.Find('Fenster').Delete(MenuItemIndex);
  end;
end;

procedure TMainForm.actNextMDIExecute(Sender: TObject);
begin
  self.Next;
end;

procedure TMainForm.actPrevMDIExecute(Sender: TObject);
begin
  self.Previous;
end;

procedure TMainForm.RefreshPanel;
begin
  actStandardID.Enabled := not DongleActive;
  actErweiterteID.Enabled := not DongleActive;
end;

procedure TMainForm.actBeendenExecute(Sender: TObject);
begin
  close;
end;

procedure TMainForm.DongleListPopupPopup(Sender: TObject);
var
  MenuItem: TMenuItem;
  i, n: dword;
  DongleInfo: array of TFtDeviceInfo;
begin
  while DongleListPopup.Items.Count > 0 do
  begin
    MenuItem := DongleListPopup.Items[0];
    DongleListPopup.Items.Delete(0);
    MenuItem.Free;
  end;

  if FT_CreateDeviceInfoList(@n) <> FT_OK then
    exit;

  SetLength(DongleInfo, n);
  if n > 0 then
  begin
    if FT_GetDeviceInfoList(@DongleInfo[0], @n) <> FT_OK then
      exit;

    i := 0;
    while (i < n) do
    begin
      MenuItem := TMenuItem.Create(DongleListPopup);
      MenuItem.Tag := i;
      MenuItem.Caption := DongleInfo[i].Description + ', Ser.Nr.: ' + DongleInfo[i].SerialNumber;
      MenuItem.Enabled := not DongleActive;
      MenuItem.OnClick := OnPopupMenuItemClick;
      if DongleInfo[i].SerialNumber = DongleSerNr then
        MenuItem.Checked := true;
      DongleListPopup.Items.Add(MenuItem);
      inc(i);
    end;
  end
  else
  begin
    MenuItem := TMenuItem.Create(DongleListPopup);
    MenuItem.Caption := 'Kein Dongle verfgbar';
    MenuItem.Enabled := false;
    DongleListPopup.Items.Add(MenuItem);
  end;
end;


procedure TMainForm.OnPopupMenuItemClick(Sender: TObject);
var
  pcDongleSerNr: array[0..8] of char;
begin
  FT_ListDevices(pointer(TMenuItem(Sender).Tag), @pcDongleSerNr, FT_LIST_BY_INDEX or FT_OPEN_BY_SERIAL_NUMBER);
  DongleSerNr := pcDongleSerNr;
end;

function TMainForm.Verbinden(): integer;
var
  err: integer;
  DongleAnzahl: dword;
  pcDongleSerNr: array[0..8] of char;
begin
  result := 0;
  err := FT_GetNumDevices(@DongleAnzahl);
  If err <> FT_OK then
  begin
    ProtokollAddLine('Fehler beim Ermitteln der Dongle Anzahl.');
    exit;
  end;
  case DongleAnzahl of
    0:  begin
          MessageDlg('Es sind keine CAN-Dongle angeschlossen.', mtError, [mbOK], 0);
          result := FT_DEVICE_NOT_FOUND;
          exit;
        end;
    1:  begin
          FT_ListDevices(pointer(0), @pcDongleSerNr, FT_LIST_BY_INDEX or FT_OPEN_BY_SERIAL_NUMBER);
          DongleSerNr := pcDongleSerNr;
        end;
  else
    if DongleSerNr = '' then
    begin
      VerindenToolBtn.CheckMenuDropdown;
      exit;
    end;
  end;
TinyCan.DeviceSnr := DongleSerNr;
TinyCan.CanSpeed := TCanSpeed(CANBaudIdx);
if TinyCAN.LoadDriver = 0 then
  begin;
  if ListenOnlyAktiv then
    TinyCAN.CanSetMode(0, OP_CAN_START_LOM, CAN_CMD_ALL_CLEAR)
  else
    TinyCAN.CanSetMode(0, OP_CAN_START, CAN_CMD_ALL_CLEAR);
  DongleActive := true;
  actVerbinden.Caption := '&Trennen';
  VerindenToolBtn.ImageIndex := 1;
  VerbindungsStat := 1;
  StatusBar.Refresh;
  end;
end;


procedure TMainForm.Trennen;
begin
  CloseDevice;
  TinyCAN.DownDriver;
end;


procedure TMainForm.CloseDevice;
begin;
  TinyCAN.CanDeviceClose;
  DongleActive := false;
  actVerbinden.Caption := '&Verbinden';
  VerindenToolBtn.ImageIndex := 0;
  VerbindungsStat := 0;
  StatusBar.Refresh;
end;

procedure TMainForm.actEinstellungenExecute(Sender: TObject);
var
  Form: TEinstellungenForm;
  i: integer;
begin
  Form := TEinstellungenForm.Create(self);

  Form.CANBaudCombo.Items.Clear;
  for i := 0 to high(CANBaudParameter) do
    Form.CANBaudCombo.Items.Add(CANBaudParameter[i]);

  Form.CANBaudCombo.ItemIndex := CANBaudIdx;
  Form.ListenOnlyCheck.Checked := ListenOnlyAktiv;
  Form.RxRefreshRateSpin.Value := RxRefreshRate;
  Form.ASCIISpalteCheck.Checked := ASCIISpalteAktiv;

  if DongleActive then
  begin
    Form.CANBaudCombo.Enabled := false;
    Form.ListenOnlyCheck.Enabled := false;
  end;

  if Form.ShowModal = mrOK then
  begin
    if not DongleActive then
    begin
      CANBaudIdx := Form.CANBaudCombo.ItemIndex;
      ListenOnlyAktiv := Form.ListenOnlyCheck.Checked;
    end;

    ASCIISpalteAktiv := Form.ASCIISpalteCheck.Checked;
    RxRefreshRate := Form.RxRefreshRateSpin.Value;
    if MDIChildCount > 0 then
      begin;
      for i := 0 to MDIChildCount-1 do
        begin
        if MDIChildren[i] is TEmpfangForm then
          begin
          TEmpfangForm(MDIChildren[i]).SetColCount;
          if RxRefreshRate > 0 then
            TEmpfangForm(MDIChildren[i]).RefreshTimer.Enabled := true
          else
            TEmpfangForm(MDIChildren[i]).RefreshTimer.Enabled := false;
          TEmpfangForm(MDIChildren[i]).RefreshTimer.Interval := RxRefreshRate;
          end;
        end;
      end;  
    StatusBar.Refresh;
  end;

  Form.Free;
end;

procedure TMainForm.actInfoExecute(Sender: TObject);
var
  Form: TForm;
begin
  Form := TInfoForm.Create(self);
  if Form.ShowModal = mrOK then
  begin
  end;
  Form.Free;
end;

procedure TMainForm.actVerbindenExecute(Sender: TObject);
begin
  if not DongleActive then
    Verbinden
  else
    Trennen;

  RefreshPanel;
end;

procedure TMainForm.CANReset;
begin
  ProtokollAddLine('Dongle-Reset senden');
  TinyCAN.CanSetMode(0, OP_CAN_RESET, CAN_CMD_RXD_FIFOS_CLEAR or CAN_CMD_TXD_FIFOS_CLEAR);
  RxNachrichtenCount := 0;
  TxNachrichtenCount := 0;
  RefreshStatusBar;
end;


function TMainForm.MDIClientOeffnen(ClientForm: TFormClass): TForm;
var
  i: integer;
begin
  if not(ClientForm.ClassParent = TEmpfangPrototypForm) then
  begin
  if MDIChildCount > 0 then
    begin;
    for i:=0 to MDIChildCount-1 do
      begin
      if (MDIChildren[i] is ClientForm) then
        begin
        result:=MDIChildren[i];
        result.BringToFront;
        result.WindowState:=wsNormal;
        exit;
        end;
      end;
    end;  
  end;
  result:=ClientForm.Create(self);
end;

procedure TMainForm.actEmpfangsFensterExecute(Sender: TObject);
var
  Form: TForm;
begin
  Form := MDIClientOeffnen(TEmpfangForm);
  if RxRefreshRate > 0 then
    TEmpfangForm(Form).RefreshTimer.Enabled := true
  else
    TEmpfangForm(Form).RefreshTimer.Enabled := false;
  TEmpfangForm(Form).RefreshTimer.Interval := RxRefreshRate;
end;

procedure TMainForm.actSendeFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TSendenForm);
end;

procedure TMainForm.actProtokollExecute(Sender: TObject);
begin
  ProtokollForm := MDIClientOeffnen(TProtokollForm);
end;

procedure TMainForm.actAnalogInstrumentFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TAnalogInstrumentForm);
end;

procedure TMainForm.actOszillogrammFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TOszillogrammForm);
end;

procedure TMainForm.actWertAnzeigeFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TWertAnzeigeForm);
end;

procedure TMainForm.actBitIndikatorFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TBitIndikatorForm);
end;

procedure TMainForm.actStandardIDExecute(Sender: TObject);
begin
  actStandardID.Checked := true;
  actErweiterteID.Checked := false;
  IDLaenge := 3;
  MaxID := $7ff;
  RefreshMDIClients;
end;

procedure TMainForm.actErweiterteIDExecute(Sender: TObject);
begin
  actStandardID.Checked := false;
  actErweiterteID.Checked := true;
  IDLaenge := 8;
  MaxID := $1fffffff;
  RefreshMDIClients;
end;

procedure TMainForm.actDezIDExecute(Sender: TObject);
begin
  actDezID.Checked := true;
  actHexID.Checked := false;
  actBinID.Checked := false;
  RefreshMDIClients;
end;

procedure TMainForm.actHexIDExecute(Sender: TObject);
begin
  actDezID.Checked := false;
  actHexID.Checked := true;
  actBinID.Checked := false;
  RefreshMDIClients;
end;

procedure TMainForm.actBinIDExecute(Sender: TObject);
begin
  actDezID.Checked := false;
  actHexID.Checked := false;
  actBinID.Checked := true;
  RefreshMDIClients;
end;

procedure TMainForm.actDezDatenExecute(Sender: TObject);
begin
  actDezDaten.Checked := true;
  actHexDaten.Checked := false;
  actBinDaten.Checked := false;
  RefreshMDIClients;
end;

procedure TMainForm.actHexDatenExecute(Sender: TObject);
begin
  actDezDaten.Checked := false;
  actHexDaten.Checked := true;
  actBinDaten.Checked := false;
  RefreshMDIClients;
end;

procedure TMainForm.actBinDatenExecute(Sender: TObject);
begin
  actDezDaten.Checked := false;
  actHexDaten.Checked := false;
  actBinDaten.Checked := true;
  RefreshMDIClients;
end;

procedure TMainForm.RefreshMDIClients;
var
  i: integer;
begin
if MDIChildCount = 0 then
  exit;
for i:=0 to MDIChildCount-1 do
  begin
    if (MDIChildren[i] is TSendenForm) then
    begin
      TSendenForm(MDIChildren[i]).NachrichtenGrid.Refresh;
      TSendenForm(MDIChildren[i]).BerechneColWidth;
    end;
    if (MDIChildren[i] is TEmpfangForm) then
    begin
      TEmpfangForm(MDIChildren[i]).NachrichtenGrid.Refresh;
      TEmpfangForm(MDIChildren[i]).BerechneColWidth;
    end;
  end;
end;

procedure TMainForm.StatusBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
begin
  if Panel.ID = 0 then
  begin
    USBImages.Draw(StatusBar.Canvas, Rect.Left+1, Rect.Top, VerbindungsStat);
    StatusBar.Canvas.TextOut(Rect.Left + USBImages.Width + 5, Rect.Top + 1,
          CANBaudParameter[CANBaudIdx]);
  end;
end;


function  TMainForm.CheckZahlenEingabe(NumString: string; var Value: byte; MaxValue: dword): integer;
var
  temp: dword;
begin
  temp := Value;
  result := CheckZahlenEingabe(NumString, temp, MaxValue);
  Value := temp;
end;

function  TMainForm.CheckZahlenEingabe(NumString: string; var Value: word; MaxValue: dword): integer;
var
  temp: dword;
begin
  temp := Value;
  result := CheckZahlenEingabe(NumString, temp, MaxValue);
  Value := temp;
end;

function TMainForm.CheckZahlenTEditEingabe(Sender: TEdit; MaxValue: dword): integer;
var
  temp: dword;
begin
  temp := Sender.Tag;
  result := CheckZahlenEingabe(Sender.Text, temp, MaxValue);
  Sender.Tag := temp;
end;

function TMainForm.CheckZahlenEingabe(NumString: string; var Value: dword; MaxValue: dword): integer;
var
  i: integer;
begin
  result := -1;
  NumString := LowerCase(trim(NumString));

  if length(NumString) < 1 then
    exit;

  case NumString[1] of
    '$':      // Hexadezimale Zahlenangabe
        begin
          Value := 0;
          i := 1;
          while (i < length(NumString)) and (Value <= MaxValue) do
          begin
            if ((NumString[i+1] >= '0') and (NumString[i+1] <= '9')) then
              Value := (Value shl 4) + (ord(NumString[i+1]) and $0f)
            else
              if ((NumString[i+1] >= 'a') and (NumString[i+1] <= 'f')) then
                Value := (Value shl 4) + (ord(NumString[i+1]) and $0f + 9)
              else
                exit;
            inc(i);
          end;
        end;
    '0'..'9': // Dezimale Zahlenangabe
        begin
          Value := 0;
          i := 0;
          while (i < length(NumString)) and (Value <= MaxValue) do
          begin
            if ((NumString[i+1] >= '0') and (NumString[i+1] <= '9')) then
              Value := (Value * 10) + (ord(NumString[i+1]) and $0f)
            else
              exit;
            inc(i);
          end;
        end;
    'b':  // Binre Zahlenangabe
        begin
          Value := 0;
          i := 1;
          while (i < length(NumString)) and (Value <= MaxValue) do
          begin
            case NumString[i+1] of
              '0': Value := (Value shl 1);
              '1': Value := (Value shl 1) + 1;
            else
              exit;
            end;
            inc(i);
          end;
        end;
  end;
end;

function TMainForm.GetIDString(ID: dword): string;
begin
  if actDezID.Checked then
    result := format('%u',[ID]);
  if actHexID.Checked then
    result := '$' + RightStr(format('00000000%x',[ID]),IDLaenge);
  if actBinID.Checked then
    result := 'Bin';
end;

procedure TMainForm.HexEditViewValue(Sender: TObject);
begin
  TEdit(Sender).Text := GetIDString(TEdit(Sender).Tag);
end;

function TMainForm.GetDataString(Data: dword): string;
var
  i, j: dword;
begin
  if actDezDaten.Checked then
    result := format('%u',[Data]);
  if actHexDaten.Checked then
    result := '$' + RightStr(format('00%x',[Data]),2);
  if actBinDaten.Checked then
  begin
    result := '00000000';
    j := Data;
    for i := 1 to 8 do
    begin
      if (j and $80) > 0 then
        result[i] := '1';
      j := j shl 1;
    end;
  end;
end;

procedure TMainForm.RefreshStatusBar;
begin
  StatusBar.Panels[1].Text := format('RxMsg: %d',[RxNachrichtenCount]);
  StatusBar.Panels[2].Text := format('TxMsg: %d',[TxNachrichtenCount]);
  StatusBar.Panels[3].Text := CanStatusStrings[ord(CanStatus)];
  StatusBar.Panels[4].Text := DrvStatusStrings[ord(DrvStatus)];
end;

procedure TMainForm.actZaehlerResetExecute(Sender: TObject);
begin
  RxNachrichtenCount := 0;
  TxNachrichtenCount := 0;
  PufferAktuell := 0;
  PufferMax := 0;
  RefreshStatusBar;
end;

procedure TMainForm.IncTxZaehler;
begin
  inc(TxNachrichtenCount);
  StatusBar.Panels[2].Text := format('TxMsg: %d',[TxNachrichtenCount]);
end;

procedure TMainForm.actInstrumentOeffnenExecute(Sender: TObject);
var
  i: integer;
  Datei: TIniFile;
  SectionsListe: TStringList;
  WerteListe: TStringList;
  tempListe: TStrings;
  FormularClass: TClass;
  Form: TForm;
begin
  SectionsListe := TStringList.Create;
  WerteListe := TStringList.Create;
  tempListe := TStringList.Create;

  OpenDialog.Title := 'Instrument laden';
  OpenDialog.DefaultExt := 'cin';
  OpenDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

  if OpenDialog.Execute then
  begin
    Datei := TIniFile.Create(OpenDialog.FileName);
    try
      FormularClass := GetClass(Datei.ReadString('Allgemein', 'Typ', ''));
      if (FormularClass <> nil) then
      begin
        Form := MDIClientOeffnen(TFormClass(FormularClass));
        if Form is TEmpfangPrototypForm then
        begin
          Datei.ReadSections(SectionsListe);
          for i := 0 to SectionsListe.Count - 1 do
          begin
            Datei.ReadSectionValues(SectionsListe.Strings[i], tempListe);
            WerteListe.AddStrings(tempListe);
          end;
          MessageDlg('Werte: '+IntToStr(WerteListe.Count),mtInformation,[mbOK],0);
          TEmpfangPrototypForm(Form).KonfigLaden(WerteListe);
        end;
      end;
    finally
      WerteListe.Free;
      tempListe.Free;
      SectionsListe.Free;
      Datei.Free;
    end;
  end;
end;



procedure TMainForm.ProtokollAddLine(s: string);
begin
  if assigned(ProtokollForm) then
  begin
    if TProtokollForm(ProtokollForm).Memo.Lines.Count >= 256 then
      TProtokollForm(ProtokollForm).Memo.Lines.Delete(0);
    TProtokollForm(ProtokollForm).Memo.Lines.Append(s);
  end;
end;



procedure TMainForm.TinyCANCanRxDEvent(Sender: TObject; index: Cardinal;
  msg: PCanMsg; count: Integer);
var
  len, i, msg_cnt: DWORD;
  form: TForm;
  can_msg: PCANrecord;
  free_msg: boolean;
begin
for msg_cnt := 1 to count do
  begin;
  new(can_msg);
  free_msg := TRUE;
  can_msg.Cmd := 0;
  len := msg^.Flags and FlagsCanLength;
  if (msg^.Flags and FlagsCanRTR) > 0 then
    can_msg.Cmd := can_msg.Cmd or $20;
  if (msg^.Flags and FlagsCanEFF) > 0 then
    can_msg.Cmd := can_msg.Cmd or $10;
  can_msg.ID := msg^.Id;
  can_msg.DLC := len;
  can_msg.Timestamp := (msg^.Time.USec div 1000) + (msg^.Time.Sec * 1000);
  if len > 0 then
    begin;
    for i := 0 to len-1 do
      can_msg.Data[i] := msg^.Data.Bytes[i];
    end;
  inc(RxNachrichtenCount);
  if MDIChildCount > 0 then
    begin;
    for i := 0 to MDIChildCount-1 do
      begin
      form := MDIChildren[i];
      if (form is TEmpfangPrototypForm) then
        TEmpfangPrototypForm(form).NeueNachricht(can_msg, free_msg);
      end;
    end;
  if free_msg then
    dispose(can_msg);

  inc(msg);
  end;
StatusBar.Panels[1].Text := format('RxMsg: %d',[RxNachrichtenCount]);
end;

procedure TMainForm.TinyCANCanStatusEvent(Sender: TObject;
  index: Cardinal; device_status: TDeviceStatus);
begin
if DrvStatus >= DRV_STATUS_CAN_OPEN then
  begin;
  if device_status.DrvStatus < DRV_STATUS_CAN_OPEN then
    CloseDevice;
  end;
if (DrvStatus <> device_status.DrvStatus) and
  (device_status.DrvStatus >= DRV_STATUS_CAN_RUN) then
  begin;
  VerbindungsStat := 2;
  StatusBar.Refresh;
  end;
DrvStatus := device_status.DrvStatus;
CanStatus := device_status.CanStatus;
RefreshStatusBar;
end;

procedure TMainForm.ResetMnuClick(Sender: TObject);
begin
CANReset;
end;

initialization
  RegisterClasses([TProtokollForm, TEmpfangForm, TSendenForm,
        TAnalogInstrumentForm, TOszillogrammForm, TBitIndikatorForm,
        TWertAnzeigeForm]);

end.
