  {***************************************************************************
                      WerteKonfig.pas  -  description
                             -------------------
    begin             : 03.12.2012
    copyright         : (C) 2012 by MHS-Elektronik GmbH & Co. KG, Germany
    autho             : Klaus Demlehner, klaus@mhs-elektronik.de
 ***************************************************************************}

{***************************************************************************
 *                                                                         *
 *   This program is free software, you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License           *
 *   version 2.1 as published by the Free Software Foundation.             *
 *                                                                         *
 ***************************************************************************}
unit WerteKonfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin, ExtCtrls, IniFiles;

type
  TWerteKonfigForm = class(TForm)
    RahmenBevel: TBevel;
    NameEdit: TEdit;
    CANIDEdit: TEdit;
    EinheitEdit: TEdit;
    BerechnungsTermEdit: TEdit;
    SkalaGroup: TGroupBox;
    OKBtn: TBitBtn;
    AbbrechenBtn: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label9: TLabel;
    LadenBtn: TBitBtn;
    SpeichernBtn: TBitBtn;
    Label10: TLabel;
    Label7: TLabel;
    ColorEdit: TColorBox;
    SizeEdit: TComboBox;
    PrecDigitEdit: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CANIDEditChange(Sender: TObject);
    procedure CANIDEditEnter(Sender: TObject);
    procedure CANIDEditExit(Sender: TObject);
    procedure LadenBtnClick(Sender: TObject);
    procedure SpeichernBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Dateiname: string;
  public
    { Public-Deklarationen }
  end;

implementation

uses Hauptfenster, IntegerTerm;

{$R *.dfm}

procedure TWerteKonfigForm.FormCreate(Sender: TObject);

begin
TMainForm(Owner.Owner).ButtonImages.GetBitmap(0, OKBtn.Glyph);
TMainForm(Owner.Owner).ButtonImages.GetBitmap(1, AbbrechenBtn.Glyph);
TMainForm(Owner.Owner).ButtonImages.GetBitmap(5, LadenBtn.Glyph);
TMainForm(Owner.Owner).ButtonImages.GetBitmap(4, SpeichernBtn.Glyph);
end;


procedure TWerteKonfigForm.OKBtnClick(Sender: TObject);
var
  i, fs, fl: integer;
  BerechnungsObj: TIntTerm;
  Varis: VarArray;

begin
BerechnungsObj := TIntTerm.Create;
Dateiname := '';

SetLength(Varis, 8);
for i := 0 to high(Varis) do
begin
  Varis[i].Name := format('d%u',[i]);
  Varis[i].Wert := 0;
end;

try
  BerechnungsObj.TermLoesen(BerechnungsTermEdit.Text, @Varis);
except
  MessageDlg('Im Berechnungs Term ist ein Fehler aufgetretten:'+#13+#10+
        BerechnungsObj.GetFehlerText, mtError, [mbOk], 0);
  BerechnungsObj.GetFehler(@fs, @fl);
  BerechnungsTermEdit.SetFocus;
  BerechnungsTermEdit.SelStart := fs-1;
  BerechnungsTermEdit.SelLength := fl;
  BerechnungsObj.Free;
  exit;
  end;
BerechnungsObj.Free;
ModalResult := mrOK;
end;


procedure TWerteKonfigForm.CANIDEditChange(Sender: TObject);

begin
TMainForm(Owner.Owner).CheckZahlenTEditEingabe(TEdit(Sender), TMainForm(Owner.Owner).MaxID);
end;


procedure TWerteKonfigForm.CANIDEditEnter(Sender: TObject);

begin
TEdit(Sender).Text := TMainForm(Owner.Owner).GetIDString(TEdit(Sender).Tag);
end;


procedure TWerteKonfigForm.CANIDEditExit(Sender: TObject);

begin
TMainForm(Owner.Owner).HexEditViewValue(Sender);
end;


procedure TWerteKonfigForm.LadenBtnClick(Sender: TObject);
var
  IniDatei: TIniFile;

begin
TMainForm(Owner.Owner).OpenDialog.Title := 'Instrumenten-Einstellungen laden';
TMainForm(Owner.Owner).OpenDialog.DefaultExt := 'cin';
TMainForm(Owner.Owner).OpenDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

if TMainForm(Owner.Owner).OpenDialog.Execute then
  begin
  IniDatei := TIniFile.Create(TMainForm(Owner.Owner).OpenDialog.FileName);
  try
    NameEdit.Text := IniDatei.ReadString('Allgemein', 'Name', TMainForm(Owner.Owner).OpenDialog.FileName);
    Dateiname := NameEdit.Text;
    CANIDEdit.Tag := IniDatei.ReadInteger('Allgemein', 'CanID', 0);
    CANIDEdit.Text := TMainForm(Owner.Owner).GetIDString(CANIDEdit.Tag);
    BerechnungsTermEdit.Text := IniDatei.ReadString('Allgemein', 'Term', 'd0');
    EinheitEdit.Text := IniDatei.ReadString('Instrument', 'Einheit', 'Einheit');
    ColorEdit.Selected := TColor(IniDatei.ReadInteger('Instrument', 'BaseColor', 0));
    SizeEdit.ItemIndex := IniDatei.ReadInteger('Instrument', 'WidgetSize', 0);
    PrecDigitEdit.Value := IniDatei.ReadInteger('Instrument', 'PrecDigits', 0);
  finally
    IniDatei.Free;
    end;
  end;
end;


procedure TWerteKonfigForm.SpeichernBtnClick(Sender: TObject);
var
  IniDatei: TIniFile;

begin
TMainForm(Owner.Owner).SaveDialog.Title := 'Instrumenten-Einstellungen speichern';
TMainForm(Owner.Owner).SaveDialog.DefaultExt := 'cin';
if Dateiname = '' then
  TMainForm(Owner.Owner).SaveDialog.FileName := NameEdit.Text + '.cin'
else
  TMainForm(Owner.Owner).SaveDialog.FileName := Dateiname;
TMainForm(Owner.Owner).SaveDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

if TMainForm(Owner.Owner).SaveDialog.Execute then
  begin
  Dateiname := TMainForm(Owner.Owner).SaveDialog.FileName;
  IniDatei := TIniFile.Create(TMainForm(Owner.Owner).SaveDialog.FileName);
  try
    IniDatei.WriteString('Allgemein', 'Typ', Owner.ClassName);
    IniDatei.WriteString('Allgemein', 'Name', NameEdit.Text);
    IniDatei.WriteInteger('Allgemein', 'CanID', CANIDEdit.Tag);
    IniDatei.WriteString('Allgemein', 'Term', BerechnungsTermEdit.Text);
    IniDatei.WriteString('Instrument', 'Einheit', EinheitEdit.Text);
    IniDatei.WriteInteger('Instrument', 'BaseColor', Integer(ColorEdit.Selected));
    IniDatei.WriteInteger('Instrument', 'WidgetSize', SizeEdit.ItemIndex);
    IniDatei.WriteInteger('Instrument', 'PrecDigits', PrecDigitEdit.Value);
  finally
    IniDatei.Free;
    end;
  end;
end;

end.
